require 'test_helper'

describe 'Fluere::Activity' do
  it 'implies AWS::Flow::Activities' do
    klass = Class.new
    klass.extend(Fluere::Activity)
    extended_modules = (class << klass; self; end).included_modules
    extended_modules.must_include AWS::Flow::Activities
  end

  describe 'with a task prefix set' do
    before { Fluere::Config.task_list_prefix = 'testprefix-' }
    after  { Fluere::Config.task_list_prefix = nil           }

    it 'prefixes the activity task_list based off the default_task_list' do
      ActivityWithTaskListPrefix = Class.new
      ActivityWithTaskListPrefix.extend(Fluere::Activity)

      ActivityWithTaskListPrefix.activity(:test_activity) {{ :default_task_list => 'task_list_name' }}

      test_activity = ActivityWithTaskListPrefix.activities.find { |a| a.name == 'ActivityWithTaskListPrefix.test_activity' }
      test_activity.options.task_list.must_equal 'testprefix-task_list_name'
    end
  end
end
