require 'test_helper'

describe 'Fluere::Workflow' do
  it 'implies AWS::Flow::Workflows' do
    klass = Class.new
    klass.extend(Fluere::Workflow)
    extended_modules = (class << klass; self; end).included_modules
    extended_modules.must_include AWS::Flow::Workflows
  end

  describe 'with a task prefix set' do
    before { Fluere::Config.task_list_prefix = 'testprefix-' }
    after  { Fluere::Config.task_list_prefix = nil           }

    it 'prefixes the workflow task_list' do
      WorkflowWithTaskListPrefix = Class.new
      WorkflowWithTaskListPrefix.extend(Fluere::Workflow)

      WorkflowWithTaskListPrefix.workflow(:test_workflow) {{ :task_list => 'task_list_name' }}

      test_workflow = WorkflowWithTaskListPrefix.workflows.find { |w| w.name == 'WorkflowWithTaskListPrefix.test_workflow' }
      test_workflow.options.task_list.must_equal 'testprefix-task_list_name'
    end
  end
end
